﻿/**
 * @project Coveo for Sitecore
 * @Copyright (c) 2005-2018, Coveo Solutions Inc.
 */

/**
 * Returns whether there is any element with the 'error' class in the current page.
 * @returns {boolean} true if there is any error, false otherwise.
 */
function hasErrors() {
    var errorElements = $$('.error');
    return errorElements.length > 0 && errorElements.any(isElementVisible);
}